/* $Id: e2_complete__files.c,v 1.7 2004/08/14 12:01:08 cairo Exp $
 * 
 * Copyright (C) 2004 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <glob.h>
#include "emelfm2.h"
#include "e2_complete.h"

gint e2_complete_files (gchar *line, gchar *word, gint pos, GList **found,
	E2_CompleteFlags *flags, gpointer data)
{
	printd (DEBUG, "complete_files (line:%s,word:%s,pos:%d,found:_,flags:%d,data:_)",
		line, word, pos, *flags);

	//FIXME: use g_pattern_match* through the virtual filesystem when it is
	//available
	gchar *word_locale = _UTF2STR (word);
	gchar *pattern = g_strconcat (word_locale, "*", NULL);
	g_free (word_locale);

	chdir (app.pane_current->path);

	glob_t matches;
	if (glob (pattern, GLOB_MARK, NULL, &matches) != 0)
		return 0;
	else
	{
		gint i;
		gboolean dirs = (*flags & E2_COMPLETE_FLAG_DIRS) && (!(*flags & E2_COMPLETE_FLAG_FILES));
		gboolean files = (*flags & E2_COMPLETE_FLAG_FILES) && (!(*flags & E2_COMPLETE_FLAG_DIRS));
		for (i = 0; i < matches.gl_pathc; i++)
		{
			if (dirs)
			{
				if (g_str_has_suffix (matches.gl_pathv[i], "/"))
					*found = g_list_append (*found, _STR2UTF (matches.gl_pathv[i]));
			} else if (files)
			{
				if (!g_str_has_suffix (matches.gl_pathv[i], "/"))
					*found = g_list_append (*found, _STR2UTF (matches.gl_pathv[i]));
			} else
				*found = g_list_append (*found, _STR2UTF (matches.gl_pathv[i]));
		}
	}
	globfree (&matches);
	g_free (pattern);
	return matches.gl_pathc;
}

