/* $Id: e2_cache.h,v 1.10 2004/08/07 22:42:50 cairo Exp $
 * 
 * Copyright (C) 2004 Florian Zaehringer (flo.zaehringer@web.de)
 * Copyright (C) 2004 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef E2_CACHE_H
#  define E2_CACHE_H

#define DEFAULT_CACHE_FILE "cache"

typedef enum
{
	//simple types
	E2_CACHE_TYPE_BOOL,
	E2_CACHE_TYPE_INT,
	E2_CACHE_TYPE_DOUBLE,
	E2_CACHE_TYPE_STR,
	E2_CACHE_TYPE_LIST,
	E2_CACHE_TYPE_TREE,
} E2_CacheType;

typedef struct _E2_Cache
{
	E2_CacheType type; 
	gchar *name;
	gpointer *data;
	gpointer sync_func;
	gpointer sync_data;
} E2_Cache;

//cache management
#define e2_cache_bool_register(name, val, def) e2_cache_int_register (name, val, def)
void e2_cache_int_register (gchar *name, gint *dbl, gint def);
void e2_cache_double_register (gchar *name, gdouble *dbl, gdouble def);
void e2_cache_str_register (gchar *name, gchar **str);
E2_Cache *e2_cache_list_register (gchar *name, GList **list);
void e2_cache_list_unregister (gchar *name);
void e2_cache_read_from_string (gchar *f[]);
void e2_cache_read_from_file (gchar *fn);
void e2_cache_write_to_file ();
void e2_cache_init ();

#endif /* ifndef E2_CACHE_H */
