/* $Id: e2_dialog.h,v 1.12 2004/08/07 22:42:50 cairo Exp $
 * 
 * Copyright (C) 2003-2004 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * @file  src/dialogs/e2_dialog.h 
 * @brief  dialog utilities header file
 *
 * This file is the header for the dialog utility functions.
 **/

#ifndef E2_DILAOG_H
#  define E2_DILAOG_H

#include "emelfm2.h"

#include "e2_about_dialog.h"
#include "e2_config_dialog.h"
#include "e2_mkdir_dialog.h"
#include "e2_select_image_dialog.h"
#include "e2_search_dialog.h"
#include "e2_view_dialog.h"

typedef enum
{
	E2_DIALOG_RUN=1<<0,
	E2_DIALOG_FREE=1<<1,
	E2_DIALOG_DONT_SHOW_ALL=1<<2,
} E2_DialogFlags;

//--old functions--|
void prepare_dialog ();
void postpare_dialog (gboolean refresh, struct _FileView *view);
//-----------------|

//extern gboolean e2_dialog_key_cb (GtkWidget *widget, GdkEventKey *event, gpointer data);
void e2_dialog_setup (GtkWidget *dialog, GtkWidget *parent);
gint e2_dialog_show (GtkWidget *dialog, GtkWidget *parent, gint buttons,
	E2_DialogFlags flags);
GtkWidget *get_dialog (GtkWidget *parent, gint type, gchar *label_text);
GtkWidget *e2_dialog_create (gchar *stock, gchar *label_text, gchar *title,
	void *func, void *data);
GtkWidget *e2_dialog_add_sw (GtkWidget *dialog);
GtkWidget *e2_dialog_add_button (GtkWidget *dialog, E2_ButtonType buttons);
GtkWidget *_e2_dialog_add_button (GtkWidget *dialog, gchar *stock,
	gchar *label, gint response);
GtkWidget *_e2_dialog_add_toggle_button (GtkWidget *dialog, gboolean value,
	gchar *label, gint response);
GtkWidget *_e2_dialog_add_check_button (GtkWidget *dialog, gboolean value,
	gchar *label, gint response);
void e2_dialog_attach_menu (GtkWidget *dialog, GtkWidget *menu);
void e2_dialog_set_positive_response (GtkWidget *dialog, gint response);
void e2_dialog_set_negative_response (GtkWidget *dialog, gint response);
void e2_dialog_set_responses (GtkWidget *dialog, gint pos, gint neg);
void e2_dialog_resize (GtkWidget *dialog, gfloat factor);
void e2_dialog_resize_with_sw (GtkWidget *dialog, GtkWidget *scrolled);
void e2_dialog_init ();

#endif /* ifndef E2_DILAOG_H */

