/* $Id: e2_toolbar.h,v 1.16 2004/03/15 20:01:48 cairo Exp $
 * 
 * Copyright (C) 2003-2004 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef E2_TOOLBAR_H
#  define E2_TOOLBAR_H

#include "emelfm2.h"
#include "e2_action.h"
#include "e2_option.h"

typedef struct _E2_ToolbarRuntime
{
	gchar *option;
	gchar *group;
	GtkToolbar *toolbar;
	GtkWidget *toolbar_container;
	GtkWidget *toolbar_container_box;
	gboolean blocked;
	gboolean hidden;
	E2_OptionSet *set;
	E2_OptionSet *show;
	E2_OptionSet *tooltips;
	E2_OptionSet *space;
	E2_OptionSet *hori;
	E2_OptionSet *type;
	E2_OptionSet *priority;
	E2_OptionSet *relief;
	E2_OptionSet *same;
	E2_OptionSet *style;
	E2_OptionSet *isize;
	GtkAllocation *alloc;
	GtkRequisition req;
	gboolean has_bookmarks;
	gboolean has_command_line;
	gboolean is_too_small;
	GtkWidget *button_rest;
	gint buttons_num_hidden;
	GList *buttons_hidden;
	gint button_last_width;
	gint button_last_height;
} E2_ToolbarRuntime;

void e2_toolbar_add_bookmarks (E2_OptionSet *set, E2_ToolbarRuntime *rt,
	GtkTreeIter *iter, E2_Action *action);
void e2_toolbar_add_menu_item (GtkWidget *menu, GtkTreeModel *model, GtkTreeIter *iter, gint level,
	E2_ToolbarRuntime *rt);
void e2_toolbar_add_item (GtkTreeModel *model, GtkTreeIter *iter, gint level,
	E2_ToolbarRuntime *rt);
void e2_toolbar_create (E2_ToolbarRuntime *rt, gchar *option,
	gchar *group_parent, gint data[]);
void _e2_toolbar_create (E2_ToolbarRuntime *rt);
void _e2_toolbar_recreate (E2_ToolbarRuntime *rt);
void e2_toolbar_destroy (E2_ToolbarRuntime *rt);

#endif /* ifndef E2_TOOLBAR_H */

