/* $Id: e2_utils.h,v 1.13 2004/06/15 22:48:14 cairo Exp $
 * 
 * Copyright (C) 2003 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef E2_UTILS_H
#  define E2_UTILS_H

#include <gtk/gtk.h>
#include <sys/types.h>

typedef struct _E2_Duo
{
	gpointer a;
	gpointer b;
} E2_Duo;

typedef struct _E2_Trio
{
	gpointer a;
	gpointer b;
	gpointer c;
} E2_Trio;

typedef struct _E2_Quartet
{
	gpointer a;
	gpointer b;
	gpointer c;
	gpointer d;
} E2_Quartet;

typedef struct _E2_Quintet
{
	gpointer a;
	gpointer b;
	gpointer c;
	gpointer d;
	gpointer e;
} E2_Quintet;

E2_Trio *e2_utils_trio_new ();
E2_Quintet *e2_utils_quintet_new ();
gchar *e2_utils_color2str (GdkColor *color);
gchar *e2_utils_str_replace (gchar *str, gchar *old, gchar *new);
gchar *e2_utils_str_stretch (gchar *str);
gchar *str_to_lower(gchar *string);
gint S_ISEXE(mode_t mode);
gchar *get_key_name(gint keyval);
void copy_entry_to_str(GtkWidget *entry, gchar *str);
gboolean is_text(gchar *filename);
gboolean is_executable (gpointer info);
void view_file(gchar *filename);
void show_help_file(gchar *filename);
GString *expand_macros(gchar *text, gchar *for_each);
void exec_system_command(gchar *command);
void exec_interface_op(gchar *command);
//void do_command(gchar *command);
gchar *e2_translate_to_filename (gchar *current_dir, gchar *new_dir);
void e2_update_settings ();
gchar *e2_utils_replace_env_vars (gchar *raw);
gchar *e2_utils_replace_options (gchar *raw);
void e2_utils_rel_path (gchar* src, gchar* dest, gchar* rel);
void e2_utils_get_abs_pos (GtkWidget *widget, gint *x, gint *y);

#endif /* ifndef E2_UTILS_H */

