/* $Id: e2_widget.h,v 1.9 2004/07/14 23:20:05 cairo Exp $
 * 
 * Copyright (C) 2004 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file COPYING. If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * @file src/utils/e2_widget.h 
 * @brief miscelleanous GtkWidget utility function headers
 *
 * This file is the header file for the miscelleanous GtkWidget utility
 * functions.
 **/

#ifndef E2_WIDGET_H
#  define E2_WIDGET_H

void e2_widget_set_tooltip (GtkTooltips *tooltips,
	GtkWidget *widget, gchar *text);
GtkWidget *e2_widget_get_icon (gchar *icon, GtkIconSize size);

GtkWidget *e2_widget_add_label (GtkWidget *box, gchar *text, gfloat align,
	gint fill, gint pad);
GtkWidget *_e2_widget_add_label (GtkWidget *box, gchar *text,
	gfloat xalign, gfloat yalign, gint fill, gint pad);

//FIXME: remove
#define add_entry(box, init_text, fill, pad) e2_widget_add_entry (box, init_text, fill, FALSE)
GtkWidget *e2_widget_add_entry (GtkWidget *box, gchar *init_text, gint fill,
	gboolean select_text);

//FIXME: remove
#define add_hbox(box, homogen, spacing, fill, pad) e2_widget_add_box (box, fill, pad, FALSE, homogen, spacing)
GtkWidget *e2_widget_get_box (gboolean vertical, gboolean homogen, gint spacing);
GtkWidget *e2_widget_add_box (GtkWidget *parent, gint fill, gint pad,
	gboolean vertical, gboolean homogen, gint spacing);

GtkWidget *e2_widget_add_sw (GtkWidget *box, GtkPolicyType h_policy,
	GtkPolicyType v_policy, gint fill, gint pad);
GtkWidget *e2_widget_get_sw (GtkPolicyType h_policy, GtkPolicyType v_policy);
void e2_widget_sw_add_with_viewport (GtkWidget *sw, GtkWidget *child);

GtkWidget *add_separator(GtkWidget *box, gint fill, gint pad);
GtkWidget *add_table(GtkWidget *box, gint rows, gint cols, gint homogen,
	gint fill, gint pad);
GtkWidget *add_label_to_table(GtkWidget *table, gchar *text,
	gfloat align, gint left, gint right, gint top, gint bottom);
GtkWidget *add_entry_to_table(GtkWidget *table, gchar *init_text,
	gint left, gint right, gint top, gint bottom);
GtkWidget *add_button_to_table(GtkWidget *table, gchar *label,
	void *func, gpointer data, gint left, gint right, gint top, gint bottom);
GtkWidget *e2_button_add_toggle_to_table(GtkWidget *table, gchar *label,
	gint state, void *func, gpointer data, gint left, gint right, gint top,
	gint bottom);
GtkWidget *add_framed_table(GtkWidget *box, gchar *title, gint rows,
	gint cols, gint fill, gint pad);
GtkWidget *add_framed_widget(GtkWidget *box, gchar *title,
	GtkWidget *widget, gint fill, gint pad);
GtkWidget *e2_widget_add_frame (GtkWidget *box, gboolean fill, gint pad,
	gchar *title, gboolean strech);
void e2_widget_set_cursor(GdkCursorType type);
GtkWidget *e2_widget_add_eventbox (GtkWidget *box, gboolean fill, gint pad);
GtkWidget *e2_widget_get_notebook (gpointer func, gpointer data);
GtkWidget *e2_widget_add_notebook (GtkWidget *box, gboolean fill, gint pad,
	gpointer func, gpointer data);
void e2_widget_get_font_pixels (GtkWidget *widget, int *width, int *height);
void e2_widget_set_font (GtkWidget *widget, char *font_string, int *width,
	int *height);

#endif /* ifndef E2_WIDGET_H */

